#version 330

#define M_PI       3.14159265358979323846f
#define M_PIH      (3.14159265358979323846f/2.f)

in  vec4 color;
out vec4 outputF;

// Prototypes
vec4 hsv_to_rgb(float h, float s, float v, float a);
vec3 hsv2rgb(vec3 c);

//----------------------------------------------------------------
// TODO:
// 1) Compute HSV [0.0, 1.0] from the input position.
// 2) Convert them to RGB using the given function to compute the output color.
//----------------------------------------------------------------

void main()
{
	float h = 0.f;

	// Find the angle between positive x and the vector
	h = atan(color.z, color.x);
	if(h < 0.f)
		h += 2*M_PI;

	h /= 2*M_PI;

	/*vec4 col = (color+1.f) / 2.0f;

	float M = max(col.x, max(col.y, col.z));
	float m = min(col.x, min(col.y, col.z));
	float C = M - m;

	if(M == col.x)
		h = mod((col.y - col.z) / C, 6.0f);
	else if(M == col.y)
		h = ((col.z - col.x) / C) + 2.0f;
	else if(M == col.z)
		h = ((col.x - col.y) / C) + 4.0f;
	h = 60.0f*h;
	h /= 2*M_PI;*/

	float s = length(vec2(color.x, color.z)); // Length of the vector from current position in the x-z plane to the center of the cone
	float v = 1.f - color.y;
	//outputF = hsv_to_rgb(h, s, v, 1.0f);
	outputF = vec4(hsv2rgb(vec3(h, s, v)), 1.0f);
}

/*
* GLSL HSV to RGB+A conversion. Useful for many effects and shader debugging.
*
* Copyright (c) 2012 Corey Tabaka
*
* Hue is in the range [0.0, 1.0] instead of degrees or radians.
* Alpha is simply passed through for convenience.
*/
 
vec4 hsv_to_rgb(float h, float s, float v, float a)
{
	float c = v * s;
	h = mod((h * 6.0), 6.0);
	float x = c * (1.0 - abs(mod(h, 2.0) - 1.0));
	vec4 color;
 
	if (0.0 <= h && h < 1.0) {
		color = vec4(c, x, 0.0, a);
	} else if (1.0 <= h && h < 2.0) {
		color = vec4(x, c, 0.0, a);
	} else if (2.0 <= h && h < 3.0) {
		color = vec4(0.0, c, x, a);
	} else if (3.0 <= h && h < 4.0) {
		color = vec4(0.0, x, c, a);
	} else if (4.0 <= h && h < 5.0) {
		color = vec4(x, 0.0, c, a);
	} else if (5.0 <= h && h < 6.0) {
		color = vec4(c, 0.0, x, a);
	} else {
		color = vec4(0.0, 0.0, 0.0, a);
	}
 
	color.rgb += v - c;
 
	return color;
}

vec3 hsv2rgb(vec3 c)
{
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}
